<template>
  <sui-modal
    v-model="visible"
    size="mini"
    v-scroll-lock="visible"
    :animation-duration="1">
    <i
      class="close icon"
      @click="hide(); sended = false"/>
    <div class="header default padding gray">
      <div class="title">Восстановление пароля</div>
    </div>
    <template v-if="!sended">
      <div class="content">
        <div class="text block">
          Для восстановления пароля <br>
          укажите свой адрес электронной&nbsp;почты.
        </div>
        <div class="ui form ">
          <div class="field">
            <div class="ui input">
              <input
                type="text"
                name=""
                @change="message = ''"
                v-model.lazy="loginreset"
                placeholder="E-mail">
            </div>
            <div
              class="error message"
              v-if="validation.firstError('loginreset')">
              {{ validation.firstError('loginreset') }}
            </div>
            <div
              class="error message"
              v-if="message"
              v-html="message"/>
          </div>
        </div>
      </div>
      <div class="actions white">
        <div class="btn block">
          <button
            @click="send"
            :disabled="!sendAllowed"
            class="ui button circular yellow inmodal">Отправить</button>
        </div>
      </div>
    </template>
    <template v-else>
      <div class="content">
        <div class="circle">
          <div class="shadow">
            <img
              svg-inline
              src="~/assets/svg/moder-modal-mail.svg"
              alt="">
          </div>
        </div>
        <div class="text block">
          На почту <strong>{{ loginreset }}</strong> отправлено письмо<br>
          с инструкцией по восстановлению пароля.
        </div>
        <div class="form block">
          <div class="actions white">
            <div class="btn block">
              <button
                @click="hide(); sended = !sended"
                class="ui button circular yellow inmodal kit box block">
                Закрыть
              </button>
            </div>
          </div>
        </div>
      </div>
    </template>
    <div
      v-if="loading"
      class="ui active inverted dimmer">
      <div class="ui text loader"/>
    </div>
  </sui-modal>
</template>

<script>
import Vue from 'vue';
import SimpleVueValidation from 'simple-vue-validator';
import { createNamespacedHelpers, mapState } from 'vuex';
import {
  SHOW_AUTH_MODAL,
  HIDE_RESET_PASSWORD_MODAL,
  SHOW_RESET_PASSWORD_MODAL,
}
  from '~/assets/js/store/actionManager/mutation-types';

const Validator = SimpleVueValidation.Validator.create({
  templates: {
    required: 'Поле обязательно к заполнению.',
    email: 'Введите корректный E-mail.',
  },
});

Vue.use(SimpleVueValidation);
const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
export default {
  name: 'ResetPasswordModal',
  data() {
    return {
      sended: false,
      loading: false,
      loginreset: '',
      message: '',
    };
  },
  computed: {
    ...mapState(['actionManager']),
    visible: {
      get() {
        return this.actionManager.showResetPasswordModal;
      },
      set(newVal) {
        if (newVal) {
          this.show();
        } else {
          this.hide();
        }
      },
    },
    sendAllowed() {
      return this.loginreset.length && !this.validation.hasError('loginreset');
    },
  },
  validators: {
    loginreset: {
      validator(value) { return Validator.value(value).required().email(); },
    },
  },
  methods: {
    ...STORE_ACTION_MANAGER.mapMutations({
      hide: HIDE_RESET_PASSWORD_MODAL,
      show: SHOW_RESET_PASSWORD_MODAL,
      showLoginModal: SHOW_AUTH_MODAL,
    }),
    send() {
      this.$validate().then(() => {
        this.loading = true;
        this.$axios.$post('/_main/user/recoverPassword', {
          email: this.loginreset,
        }).then(({ data }) => {
          if (data.success) {
            this.sended = true;
          } else {
            this.message = data.message;
          }
        }).catch((e) => {
          console.error(e);
        }).finally(() => {
          this.loading = false;
        });
      });
    },
  },
};
</script>

<style lang="scss" scoped>
  .block {
    display: block;
  }
  .ui.modal>.actions.white {
    padding-top: 0;
  }
  .modal {
    &.modal {
      position: absolute;
    }
    .text.block {
      display: block;
      text-align: center;
      font-size: 0.8125rem;
      padding: 0.5rem 0 1.25rem;
      @media screen and (max-width: 767px) {
        font-size: 0.9375rem;
        padding: 0.5rem 0 1rem;
      }
    }
    .btn.block {
      margin: 0;
      padding-bottom: 1.5rem;
    }
    .circle {
      display: block;
      width: 9.625rem;
      height: 9.625rem;
      margin: 0 auto;
      position: relative;
      &:after {
        display: none;
      }
    }
    .shadow {
      display: flex;
      justify-content: center;
      align-items: center;
      top: 50%;
      left: 50%;
      width: 9rem;
      height: 9rem;
      margin-left: -4.5rem;
      margin-top: -4.5rem;
      border-radius: 100%;
      position: absolute;
      background-color: #edf3fa;
      .svg {
        width: 4rem;
        fill: #5997d7;
      }
    }
  }
</style>
